GuiCommand:
Name: Draft PointArray
MenuLocation: Modification , Array tools , Point array
Modify , Point array
Workbenches: Draft_Workbench, BIM_Workbench
Version: 0.18
SeeAlso: Draft_OrthoArray, Draft_PolarArray, Draft_CircularArray, Draft_PathArray, Draft_PathLinkArray, Draft_PointLinkArray
Draft PointArray
Description
The Draft PointArray command creates a regular array from a selected base object by placing copies at the points from a point object. Use the Draft PointLinkArray command to create a more efficient Link array instead. Except for the type of array that is created, Link array or regular array, the Draft PointLinkArray command is identical to this command.
The base object can be a 2D object created with the Draft Workbench or Sketcher Workbench, but also a 3D object such as those created with the Part Workbench, PartDesign Workbench or BIM Workbench.
The point object can be any object with a shape and vertices (including a Std Part containing one or more of such objects), as well as a mesh and a point cloud. Duplicate points in the point object are filtered out.
![](https://raw.githubusercontent.com/FreeCAD/FreeCAD-documentation/master/wiki/images/Draft_PointArray_Example.png)
Usage
- Select the object you wish to array.
- Add the point object to the selection.
- There are several ways to invoke the command:
- Press the
Point array button.
- Draft: Select the Modification → Array tools →
Point array option from the menu.
- BIM: Select the Modify →
Point array option from the menu.
- Press the
- The array is created.
- Optionally change the properties of the array in the Property editor.
Properties
See also: Property editor.
A Draft PointArray object is derived from a Part Feature object and inherits all its properties (with the exception of some View properties that are not inherited by Link arrays). The following properties are additional unless otherwise stated:
Data
{{TitleProperty|Link}}
The properties in this group are only available for Link arrays. See Std LinkMake for more information.
-
Scale|Float
-
Scale Vector|Vector|Hidden
-
Scale List|VectorList
-
Visibility List|BoolList|Hidden
-
Placement List|PlacementList|Hidden
-
Element List|LinkList|Hidden
-
_ Link Touched|Bool|Hidden
-
_ Child Cache|LinkList|Hidden
-
Colored Elements|LinkSubHidden|Hidden
-
Link Transform|Bool
{{TitleProperty|Objects}}
-
Base|Link: specifies the object to duplicate in the array.
-
Count|Integer: (read-only) specifies the number of elements in the array. This number is determined by the number of points in the Point Object.
-
Expand Array|Bool: specifies whether to expand the array in the Tree view to enable the selection of its individual elements. Only available for Link arrays.
-
Extra Placement|Placement: : specifies an additional placement, translation and rotation, for each element in the array.
-
Fuse|Bool: specifies if overlapping elements in the array are fused or not. Not used for Link arrays. (v1.0)
-
Point Object|Link: specifies the object whose points are used to position the elements in the array.
View
{{TitleProperty|Link}}
The properties in this group, with the exception of the inherited property, are only available for Link arrays. See Std LinkMake for more information.
-
Draw Style|Enumeration
-
Line Width|FloatConstraint
-
Override Material|Bool
-
Point Size|FloatConstraint
-
Selectable|Bool: this is an inherited property that appears in the Selection group for other arrays
-
Shape Material|Material
{{TitleProperty|Base}}
The properties in this group, with the exception of the inherited property, are only available for Link arrays. See Std LinkMake for more information.
-
Child View Provider|PersistentObject|Hidden
-
Material List|MaterialList|Hidden
-
Override Color List|ColorList|Hidden
-
Override Material List|BoolList|Hidden
-
Proxy|PythonObject|Hidden: this is an inherited property.
{{TitleProperty|Display Options}}
The properties in this group are inherited properties. See Part Feature for more information.
-
Bounding Box|Bool: this property is not inherited by Link arrays.
-
Display Mode|Enumeration: for Link arrays it can be {{value|Link}} or {{value|ChildView}}. For other arrays it can be: {{value|Flat Lines}}, {{value|Shaded}}, {{value|Wireframe}} or {{value|Points}}
-
Show In Tree|Bool
-
Visibility|Bool
{{TitleProperty|Draft}}
-
Pattern|Enumeration: not used.
-
Pattern Size|Float: not used.
{{TitleProperty|Object style}}
The properties in this group are not inherited by Link arrays.
Scripting
See also: Autogenerated API documentation and FreeCAD Scripting Basics.
To create a point array use the make_point_array
method ((v0.19) ) of the Draft module. This method replaces the deprecated makePointArray
method.
point_array = make_point_array(base_object, point_object, extra=None, use_link=True)
-
base_object
is the object to be arrayed. It can also be theLabel
(string) of an object in the current document. -
point_object
is the object containing the points. It can also be theLabel
(string) of an object in the current document. It should have aGeometry
,Links
, orComponents
property containing points. -
extra
is anApp.Placement
, anApp.Vector
or anApp.Rotation
that displaces each element. -
If
use_link
isTrue
the created elements are App Links instead of regular copies.
Example:
import FreeCAD as App
import Draft
doc = App.newDocument()
polygon = Draft.make_polygon(3, radius=500.0)
p1 = Draft.make_point(App.Vector(1500, 0, 0))
p2 = Draft.make_point(App.Vector(2500, 0, 0))
p3 = Draft.make_point(App.Vector(2000, 1000, 0))
compound = doc.addObject("Part::Compound", "Compound")
compound.Links = [p1, p2, p3]
point_array = Draft.make_point_array(polygon, compound)
doc.recompute()
⏵ documentation index > Draft > Draft PointArray
This page is retrieved from https://github.com/FreeCAD/FreeCAD-documentation/blob/main/wiki/Draft_PointArray.md